//    WeIRCd 0.4 IRC server software - main file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define COMPILEOPTION_MAXNICKLEN 25
#define COMPILEOPTION_MAXUSERIDLEN 10
#define COMPILEOPTION_MAXUSERS 2000 //don't hesitate to put a big number here, only 4 bytes for each unused user are lost for an empty pointer
#define COMPILEOPTION_MAXREALNAMELEN 50
#define COMPILEOPTION_MAXCHANSPERUSER 20
#define COMPILEOPTION_MAXHOSTLEN 60

char version[] = "0.4-prealpha2";

#include "weircd.h"

int main() {
	weircdInit(version);
#ifndef NOFORK
	int forking = forkIntoBackground();
	if (forking < 0) {
		if (forking < -1) {
			printf("ERROR: Forking failed.\n");
			return -1;
		}else{
			return 0;
		}
	}
#endif
	if (readconfig(0) < 0) {
		printf("%s    > Error processing config file, Cancelling.\n",startupprefixsub);
		return -1;
	}
	socketsStartup(currentoptions.bindip,currentoptions.bindport);
	return weircdMainLoop();
}
