//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void sendStartup(int userid) {
	vsnd("NOTICE AUTH :*** Welcome. Send your authentication",userid);
}
void authpong(int userid) {
	if (userpointers[userid]->authpongvalue > 0) {return;}
	if (userpointers[userid]->authed == true) {return;}
	long l = time(NULL);
	userpointers[userid]->authpongvalue = l;
	unsigned char response[400];
	snprintf(&response[0],399,"PING :%ld",l);
	response[399] = 0;
	vsnd(response,userid);
	return;
}
void makeuseridvalid(unsigned char* userid) {
	unsigned char neu[20] = "";
	if (strlen(userid) < 1) {
		strcpy(userid,"");
		return;
	}
	int fcount2;
	bool isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(userid) - 1 && strlen(neu) < 9 && fcount2 < 20) {
		isokay = false;
		if (userid[fcount2] >= 65 && userid[fcount2] <= 90) {//big letters
			isokay = true;
		}
		if (userid[fcount2] >= 97 && userid[fcount2] <= 122) {//small letters
			isokay = true;
		}
		if (userid[fcount2] >= 48 && userid[fcount2] <= 57) {//numbers
			isokay = true;
		}
		if (userid[fcount2] == 95 && fcount2 >= 1) {//underlined _ - NOT AT THE BEGINNING
			isokay = true;
		}
		if (isokay == true) {neu[strlen(neu)+1] = 0;neu[strlen(neu)] = userid[fcount2];}
		fcount2 += 1;
	}
	strcpy(userid,neu);
}
bool nicknamevalid(char* nick) {
	if (strlen(nick) < 1) {
		return false;
	}
	int fcount2;
	int charcount;
	charcount = 0;
	bool isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(nick) - 1) {
		isokay = false;
		if (nick[fcount2] >= 65 && nick[fcount2] <= 90) {//big letters
			isokay = true;charcount += 1;
		}
		if (nick[fcount2] >= 97 && nick[fcount2] <= 122) {//small letters
			isokay = true;charcount += 1;
		}
		if (nick[fcount2] >= 48 && nick[fcount2] <= 57 && fcount2 >= 1) {//numbers - NOT AT THE BEGINNING
			isokay = true;
		}
		if (nick[fcount2] == '_' || nick[fcount2] == '^' || nick[fcount2] == '|' || nick[fcount2] == '[' || nick[fcount2] == ']' || nick[fcount2] == '(' || nick[fcount2] == ')' || nick[fcount2] == '-') {//special chars
			isokay = true;
		}
		if (isokay == false) {return false;}
		fcount2 += 1;
	}
	if (charcount <= 0) {return false;}
	return true;
}
bool nickused(const unsigned char* nick) {
	if (strlen(nick) < 1) {return false;}
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (strcasecmp(userpointers[r]->nickname,nick) == 0) {
				return true;
			}
		}
		r += 1;
	}
	return false;
}
void notenoughparameters(int userid, const unsigned char* command) {
	unsigned char send[400];
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		snprintf(&send[0],399,":%s 461 %s %s :Not enough parameters",currentoptions.serverdomain,userpointers[userid]->nickname,command);
	}else{
		snprintf(&send[0],399,":%s 461 %s %s :Not enough parameters",currentoptions.serverdomain,"AUTH",command);
	}
	send[399] = 0;
	vsnd(send,userid);
}
void sendlusers(int userid) {
	unsigned char send[501];
	snprintf(&send[0],499,":%s 251 %s :There are %d users on 1 server",cuo.svd,un(userid),usercount());
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 255 %s :I have %d clients and 0 servers",cuo.svd,un(userid),usercount());
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 265 %s :Current local  users: %d  Max: %d",cuo.svd,un(userid),usercount(),usercount());
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 266 %s :Current global users: %d  Max: %d",cuo.svd,un(userid),usercount(),usercount());
	send[499] = 0;vsnd(send,userid);
}
void sendwhois(int userid,int targetid) {
	unsigned char send[501];
	snprintf(&send[0],499,":%s 311 %s %s %s %s * :%s",cuo.svd,un(userid),un(targetid),userpointers[targetid]->suserid,userpointers[targetid]->host,userpointers[targetid]->realname);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 312 %s %s irc.eloxoph.net :irc.eloxoph.net",cuo.svd,un(userid),un(targetid));
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 318 %s %s :End of /WHOIS",cuo.svd,un(userid),un(targetid));
	send[499] = 0;vsnd(send,userid);
}
void authdone(int userid) {
	userpointers[userid]->authed = true;
	unsigned char send[501];
	snprintf(&send[0],499,":%s 001 %s :Welcome to %s %s",cuo.svd,un(userid),cuo.networkname,un(userid));
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 002 %s :Your host is %s, running WeIRCd%s",cuo.svd,un(userid),cuo.svd,version);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,"NOTICE %s :Your host is %s, running WeIRCd%s",un(userid),cuo.svd,version);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 003 %s :This server was created on a rainy monday",cuo.svd,un(userid));
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 004 %s :%s WeIRCd%s aAbBcCdDeEfFGhHiIjkKlLmMnNopPQrRsStTuUvVwWxXyYzZ01234569*@ bcdefFhiIklmnoPqstv",cuo.svd,un(userid),cuo.svd,version);
	snprintf(&send[0],499,":%s 005 %s CHANTYPES=# PREFIX=(aohv)!@%+ NETWORK=%s :are supported by this server",cuo.svd,un(userid),cuo.networkname);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 005 %s CHANLIMIT=#:%d IRCD=WeIRCd NICKLEN=%d CASEMAPPING=ascii USERLEN=9 :are supported by this server",cuo.svd,un(userid),cuo.vmaxchansperuser,COMPILEOPTION_MAXNICKLEN);
	send[499] = 0;vsnd(send,userid);
	sendlusers(userid);
	snprintf(&send[0],499,":%s 422 %s :No MOTD file.",cuo.svd,un(userid));
	send[499] = 0;vsnd(send,userid);
}
int usercount() {
	int r = 0;
	int k = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->pleaseremove == false && userpointers[r]->authed == true) {
				k += 1;
			}
		}
		r += 1;
	}
	return k;
}
#include "weircd_irccommands.c"
void userCMD(int userid, const unsigned char* command, const unsigned char* parameters) {
	unsigned char cmd[40];
	strncpy(cmd,command,39);cmd[39] = 0;
	unsigned char params[520];
	strncpy(params,parameters,519);params[519] = 0;
	printf(">>[%d] %s %s\n",userid,cmd,parameters);
	if (strcasecmp(cmd,"NICK") == 0) {cmd_nick(userid,params);return;}
	if (strcasecmp(cmd,"USER") == 0) {cmd_user(userid,params);return;}
	if (strcasecmp(cmd,"PONG") == 0) {cmd_pong(userid,params);return;}
	if (strcasecmp(cmd,"PRIVMSG") == 0) {cmd_privmsg(userid,params);return;}
	if (strcasecmp(cmd,"LUSERS") == 0) {if (x(userid,"LUSERS")) {return;}sendlusers(userid);return;}
	if (strcasecmp(cmd,"PING") == 0) {cmd_ping(userid,params);return;}
	if (strcasecmp(cmd,"NOTICE") == 0) {cmd_notice(userid,params);return;}
	if (strcasecmp(cmd,"QUIT") == 0) {cmd_quit(userid,params);return;}
	if (strcasecmp(cmd,"WHOIS") == 0) {cmd_whois(userid,params);return;}
}
