//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

int x(int uid, const unsigned char* cmd) {
	unsigned char response[500];
	if (userpointers[uid]->authed == true) {
		return 0;
	}else{
		if (strcasecmp(userpointers[uid]->nickname,"") != 0) {
			snprintf(&response[0],499,":%s 451 %s %s :Please register first.",cuo.svd,un(uid),cmd);
		}else{
			snprintf(&response[0],499,":%s 451 * %s :Please register first.",cuo.svd,cmd);
		}
		response[499] = 0;
		vsnd(response,uid);
		return -1;
	}
}
void cmd_nick(int userid, unsigned char* params) {
	unsigned char response[500];
	if (strstw(params,":") == true) {cut(params,1);}trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"NICK");return;
	}
	if (nicknamevalid(params) == false) {
		if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
			snprintf(&response[0],499,":%s 432 * %s :Erroneus Nickname",cuo.svd,params);
		}else{
			snprintf(&response[0],499,":%s 432 %s %s :Erroneus Nickname",cuo.svd,userpointers[userid]->nickname,params);
		}
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	if (nickused(params) == true) {
		if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
			snprintf(&response[0],499,":%s 433 * %s :Nickname is already in use",cuo.svd,params);
		}else{
			snprintf(&response[0],499,":%s 433 %s %s :Nickname is already in use",cuo.svd,userpointers[userid]->nickname,params);
		}
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		//send nickchange message here
	}
	strcpy(userpointers[userid]->nickname,params);
	if (strcasecmp(userpointers[userid]->suserid,"") != 0 && userpointers[userid]->authed == false) {
		authpong(userid);
	}
}
void cmd_pong(int userid, unsigned char* params) {
	trimleft(params);
	if (userpointers[userid]->authpongvalue > 0 && userpointers[userid]->authed == false) {
		if (strstw(params,":") == true) {cut(params,1);trimleft(params);}
		if (atol(params) == userpointers[userid]->authpongvalue) {
			authdone(userid);
		}
	}
}
void cmd_notice(int userid, unsigned char* params) {
	if (x(userid,"NOTICE")) {return;}
	unsigned char response[513];
	unsigned char targets[100];
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"NOTICE");return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,"NOTICE");return;
	}
	if (charpos(params,':') >= strlen(params) - 1) {
		snprintf(&response[0],499,":%s 412 %s :No text to send",cuo.serverdomain,un(userid));
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	strncat(targets,params,99);targets[99] = 0;
	cutonfirstspace(targets);
	allesnachzeichen(32,params,params);
	if (strstw(params,":") == false) {
		notenoughparameters(userid,"NOTICE");return;
	}
	cut(params,1);
	if (strstw(targets,"#") == true) {
		printf("NOTICE:CHAN\n");
	}else{
		int u;
		u = ubn(targets);
		if (u < 0) {
			snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.serverdomain,un(userid),targets);
			response[499] = 0;
			vsnd(response,userid);
			return;
		}
		snprintf(&response[0],512,":%s!%s@%s NOTICE %s :%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->ip,un(u),params);
		response[512] = 0;
		vsnd(response,u);
		return;
	}
}
void cmd_ping(int userid, unsigned char* params) {
	unsigned char response[313];
	trimleft(params);
	if (strstw(params,":") == true) {cut(params,1);}trimleft(params);
	cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"PING");return;
	}
	snprintf(&response[0],312,":%s PONG %s :%s",cuo.svd,cuo.svd,params);
	response[312] = 0;vsnd(response,userid);
}
void cmd_privmsg(int userid, unsigned char* params) {
	if (x(userid,"PRIVMSG")) {return;}
	unsigned char response[513];
	unsigned char targets[100];
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"PRIVMSG");return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,"PRIVMSG");return;
	}
	if (charpos(params,':') >= strlen(params) - 1) {
		snprintf(&response[0],499,":%s 412 %s :No text to send",cuo.serverdomain,un(userid));
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	strncat(targets,params,99);targets[99] = 0;
	cutonfirstspace(targets);
	allesnachzeichen(32,params,params);
	if (strstw(params,":") == false) {
		notenoughparameters(userid,"PRIVMSG");return;
	}
	cut(params,1);
	if (strstw(targets,"#") == true) {
		printf("PRIVMSG:CHAN\n");
	}else{
		int u;
		u = ubn(targets);
		if (u < 0) {
			snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.serverdomain,un(userid),targets);
			response[499] = 0;
			vsnd(response,userid);
			return;
		}
		snprintf(&response[0],512,":%s!%s@%s PRIVMSG %s :%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->ip,un(u),params);
		response[512] = 0;
		vsnd(response,u);
		return;
	}
}
void cmd_whois2(int userid, unsigned char* params) {
	unsigned char response[513];
	int u;
	u = ubn(params);
	if (u < 0) {
		snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.serverdomain,un(userid),params);
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	sendwhois(userid,u);
}
void cmd_whois(int userid, unsigned char* params) {
	if (x(userid,"WHOIS")) {return;}
	unsigned char tp1[500];
	unsigned char tp2[500];
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"WHOIS");return;
	}
	strncpy(tp1,params,499);tp1[499] = 0;
	int r = 0;
	while (charpos(tp1,',') > 0) {
		allesvorzeichen(',',tp2,tp1);
		allesnachzeichen(',',tp1,tp1);
		cmd_whois2(userid,tp2);
	}
	cmd_whois2(userid,tp1);
}
void cmd_quit(int userid, unsigned char* params) {
	trimleft(params);
	if (strstw(params,":") == true) {cut(params,1);}trimleft(params);trimright(params);
	userQuit(userid,USERQUIT_QUIT);
}
void cmd_user(int userid, unsigned char* params) {
	unsigned char response[500];
	if (strcasecmp(userpointers[userid]->suserid,"") != 0) {
		if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
			snprintf(&response[0],499,":%s 462 * :Please register only once",cuo.svd);
		}else{
			snprintf(&response[0],499,":%s 462 %s :Please register only once",cuo.svd,un(userid));
		}
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"USER");return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,"USER");return;
	}
	unsigned char muserid[10] = "";
	strncpy(muserid,params,9);muserid[9] = 0;
	cutonfirstspace(muserid);
	makeuseridvalid(muserid);
	if (strlen(muserid) <= 0) {strcpy(muserid,"invalid");}
	strcpy(userpointers[userid]->suserid,"~");strncat(userpointers[userid]->suserid,muserid,COMPILEOPTION_MAXUSERIDLEN -1);
	userpointers[userid]->suserid[COMPILEOPTION_MAXUSERIDLEN] = 0;
	allesnachzeichen(':',params,params);
	trimleft(params);trimright(params);
	strncpy(userpointers[userid]->realname,params,COMPILEOPTION_MAXREALNAMELEN - 1);
	userpointers[userid]->realname[COMPILEOPTION_MAXREALNAMELEN] = 0;
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		authpong(userid);
	}
}
